# very thin safearray support
from ctypes import *
from comtypes.typeinfo import SAFEARRAYBOUND
from comtypes.automation import VT_I4, VT_R8

class SAFEARRAY(Structure):
    _fields_ = [("cDims", c_ushort),
                ("fFeatures", c_ushort),
                ("cbElements", c_ulong),
                ("cLocks", c_ulong),
                ("pvData", c_void_p),
                ("rgsabound", SAFEARRAYBOUND * 1)]

    def dump(self):
        print "cDims", self.cDims
        print "fFeatures", self.fFeatures
        print "cLocks", self.cLocks
        print "cbElements", self.cbElements


    def __getitem__(self, index):
        ix = c_int(index)
        data = c_double()
        res = windll.oleaut32.SafeArrayGetElement(byref(self), byref(ix), byref(data))
        if res:
            raise WinError(res)
        return data.value

    def __iter__(self):
        ix = c_int()
        data = c_double()
        get = windll.oleaut32.SafeArrayGetElement
        while 1:
            if get(byref(self), byref(ix), byref(data)):
                raise StopIteration
            yield data.value
            ix.value += 1
            

if __name__ == "__main__":
    rgsa = (SAFEARRAYBOUND * 2)()
    rgsa[0].lLBound = 0
    rgsa[0].cElements = 8
    rgsa[1].lLBound = 0
    rgsa[1].cElements = 5

    windll.oleaut32.SafeArrayCreate.restype = POINTER(SAFEARRAY)
    array = windll.oleaut32.SafeArrayCreate(VT_I4, len(rgsa), rgsa)[0]
    array.dump()
    for i, data in enumerate(array):
        print i, data

    ##print array[-1]
    print array[:]
